---
product: "AG Grid"
title: "Formulas"
description: "Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Formula Editor"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-editor-component/"
    - title: "Formula Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-reference/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-custom-functions/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Formulas

Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/formula-editor-demo.BvoS4BcB.mp4)

## Enabling Formulas

To enable formulas, set the column property `allowFormula: true` on one or more columns and ensure rows have [Row IDs](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-ids/#row-ids).

```js
const gridOptions = {
    columnDefs: [
        { field: 'product' },
        { field: 'price' },
        { field: 'quantity' },
        { field: 'subtotal', allowFormula: true },
        { field: 'tax', allowFormula: true },
        { field: 'total', allowFormula: true },
    ],
    cellSelection: {
        handle: {
            mode: 'fill',
        },
    },
    getRowId: (params) => String(params.data.rid),

    // other grid options ...
}
```

#### Formulas

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, FormulaModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  CellSelectionModule,
  ClientSideRowModelModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
]);

let gridApi: GridApi;

const valueFormatter = ({ value }: ValueFormatterParams) =>
  `$ ${Number(value).toFixed(2)}`;
const getRowId = (params: GetRowIdParams) => String(params.data.id);

const columnDefs: ColDef[] = [
  { field: "product" },
  { field: "price", valueFormatter: valueFormatter },
  { field: "quantity", headerName: "Qty", maxWidth: 100 },
  { field: "subtotal", valueFormatter: valueFormatter, allowFormula: true },
  {
    field: "tax",
    headerName: "Tax (10%)",
    valueFormatter: valueFormatter,
    allowFormula: true,
  },
  { field: "total", valueFormatter: valueFormatter, allowFormula: true },
];

const gridOptions: GridOptions = {
  columnDefs,
  getRowId,
  defaultColDef: {
    editable: true,
    flex: 1,
  },
  cellSelection: {
    handle: {
      mode: "fill",
    },
  },
  rowData: [
    {
      id: 1,
      product: "Apples",
      price: 1.25,
      quantity: 4,
      subtotal: '=REF(COLUMN("price"),ROW(1))*REF(COLUMN("quantity"),ROW(1))',
      tax: '=REF(COLUMN("subtotal"),ROW(1))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(1))+REF(COLUMN("tax"),ROW(1))',
    },
    {
      id: 2,
      product: "Oranges",
      price: 0.8,
      quantity: 6,
      subtotal: '=REF(COLUMN("price"),ROW(2))*REF(COLUMN("quantity"),ROW(2))',
      tax: '=REF(COLUMN("subtotal"),ROW(2))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(2))+REF(COLUMN("tax"),ROW(2))',
    },
    {
      id: 3,
      product: "Bananas",
      price: 0.5,
      quantity: 10,
      subtotal: '=REF(COLUMN("price"),ROW(3))*REF(COLUMN("quantity"),ROW(3))',
      tax: '=REF(COLUMN("subtotal"),ROW(3))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(3))+REF(COLUMN("tax"),ROW(3))',
    },
    {
      id: 4,
      product: "Grapes",
      price: 2.1,
      quantity: 3,
      subtotal: '=REF(COLUMN("price"),ROW(4))*REF(COLUMN("quantity"),ROW(4))',
      tax: '=REF(COLUMN("subtotal"),ROW(4))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(4))+REF(COLUMN("tax"),ROW(4))',
    },
    {
      id: 5,
      product: "Plums",
      price: 1.5,
      quantity: 2,
      subtotal: '=REF(COLUMN("price"),ROW(5))*REF(COLUMN("quantity"),ROW(5))',
      tax: '=REF(COLUMN("subtotal"),ROW(5))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(5))+REF(COLUMN("tax"),ROW(5))',
    },
    {
      id: 6,
      product: "Peaches",
      price: 1,
      quantity: 3,
      subtotal: '=REF(COLUMN("price"),ROW(6))*REF(COLUMN("quantity"),ROW(6))',
      tax: '=REF(COLUMN("subtotal"),ROW(6))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(6))+REF(COLUMN("tax"),ROW(6))',
    },
    {
      id: 7,
      product: "Mangos",
      price: 2.45,
      quantity: 1,
      subtotal: '=REF(COLUMN("price"),ROW(7))*REF(COLUMN("quantity"),ROW(7))',
      tax: '=REF(COLUMN("subtotal"),ROW(7))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(7))+REF(COLUMN("tax"),ROW(7))',
    },
    {
      id: 8,
      product: "Strawberries",
      price: 1.8,
      quantity: 4,
      subtotal: '=REF(COLUMN("price"),ROW(8))*REF(COLUMN("quantity"),ROW(8))',
      tax: '=REF(COLUMN("subtotal"),ROW(8))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(8))+REF(COLUMN("tax"),ROW(8))',
    },
  ],
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Formulas](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas/typescript/)

## Formula Editor Component

The Formula Cell Editor is the default editor for `allowFormula: true` columns unless a custom `cellEditor` is provided. It tokenises references, highlights ranges, and provides function autocomplete while typing.

To opt out, set a `cellEditor` on the column. Formulas still evaluate, but the formula editor features are disabled.

See [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-editor-component/) for details and examples.

## Formula Syntax

Formulas are text strings that start with an equals sign (`=`) and can contain references, functions, operators, and constants.

### Basics

- `=` prefix indicates a formula.
- Constants can be numbers (e.g. `3.14`, `-7`), strings (e.g. `"Hello"`), or booleans (`TRUE`, `FALSE`).
- Standard operator precedence applies (BODMAS/PEMDAS).

### Cell References

Cell references use column letters plus row numbers (e.g. `A1`, `B2`). Rows are 1-based and columns continue past `Z` with `AA`, `AB`, `AC`, and so on.

Relative references move as the grid changes. Absolute references stay fixed using `$`:

- `=$A$1` locks column and row.
- `=A$1` locks the row only.
- `=$A1` locks the column only.

#### Long-Form References

The grid stores formulas in a long-hand format using column and row IDs so references remain valid across row and column changes that happen while the grid is not displaying the data. The editor converts them back to shorthand when users edit a cell.

If formulas are supplied directly in data, use the long-hand format to avoid row position drift. See the notes in [Formula Reference](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-reference/) for the conversion rules.

### Cell Ranges

Ranges refer to a block of cells using a top-left and bottom-right reference separated by `:` (e.g. `A1:B2`).

### Functions

Formulas support built-in functions such as `SUM`, `AVERAGE`, and `CONCAT`. See [Formula Reference](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-reference/) for the full list of supported functions, errors, and operators.

## Feature Interactions / Compatibility

| Feature | Status | Notes |
| --- | --- | --- |
| [Fill Handle](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-selection-fill-handle/) | Supported | Dragging from a formula offsets relative refs to the target row (e.g. `=B1+C2` becomes `=B2+C3`), so with a filter active they follow the visible rows. Absolute refs remain fixed. |
| [Cell Selection](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-selection/) | Supported | Required for range highlights and range handle editing in the formula editor. |
| [Row Numbers](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-numbers/) | Supported | Enabled by default; clicking a row number adds a row range to the formula. |
| [Cell Expressions](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-expressions/#cell-expressions) | Not supported |  |
| [Tree Data](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tree-data/) and [Row Grouping](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping/) | Not supported |  |
| [Pivoting](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/pivoting/) and [Aggregation](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/aggregation/) | Not supported |  |
| [Master Detail](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/master-detail/) | Not supported |  |
| [Server-Side](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/server-side-model/), [Infinite](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/infinite-scrolling/), and [Viewport](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/viewport/) Row Models | Not supported |  |

## Formula Data Source

Formulas can be backed by a custom data source. This example uses a Map-based store for formula values:

```js
const formulaStore = new Map();
const formulaKey = (rowId, colId) => `${rowId}-${colId}`;

const gridOptions = {
    columnDefs: [
        { field: 'sales' },
        { field: 'tax', allowFormula: true },
    ],
    formulaDataSource: {
        getFormula: ({ column, rowNode }) => formulaStore.get(formulaKey(rowNode.id, column.getColId())),
        setFormula: ({ column, rowNode, formula }) => {
            const key = formulaKey(rowNode.id, column.getColId());
            if (formula === undefined) {
                formulaStore.delete(key);
            } else {
                formulaStore.set(key, formula);
            }
        },
    },

    // other grid options ...
}
```

#### Formula Data Source

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  RowApiModule,
  TextEditorModule,
  ValueFormatterFunc,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { FormulaModule } from "ag-grid-enterprise";
import { RowData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowApiModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
]);

type RowData = {
  id: string;
  product: string;
  price: number;
  quantity: number;
  subtotal?: string | number;
  total?: string | number;
};

let gridApi: GridApi<RowData>;

function seeRowData() {
  gridApi.forEachNode((node) =>
    console.log(
      `Row ${node.rowIndex}, ID: ${node.id}, Data: ${JSON.stringify(node.data)}`,
    ),
  );
}

function seeFormulas() {
  if (formulaStore.size === 0) {
    console.log("No formulas in store");
  } else {
    console.log("Stored formulas:");
    formulaStore.forEach((value, key) =>
      console.log(`Key: ${key}, Formula: ${value}`),
    );
  }
}

const currencyFormatter: ValueFormatterFunc<RowData> = ({ value }) =>
  `$ ${Number(value ?? 0).toFixed(2)}`;
const getRowId: GetRowIdFunc<RowData> = (params) => String(params.data.id);

const formulaKey = (rowId: string, colId: string) => `${rowId}-${colId}`;

// Simple in-memory store to keep formulas outside rowData
// .. initialise with some initial formulas.
// .. Note: formulas in the grid are normalised into the long-hand format as shown below. As such, when using
//          an external data store, formulas will be stored in this long-hand format. Users can and should continue
//          to use the short-hand format.
//          See https://www.ag-grid.com/javascript-data-grid/formulas/#long-form-references for more.
const formulaStore = new Map<string, string>([
  [
    formulaKey("a_01", "total"),
    '=REF(COLUMN("price"),ROW("a_01"))*REF(COLUMN("quantity"),ROW("a_01"))',
  ],
  [
    formulaKey("o_02", "total"),
    '=REF(COLUMN("price"),ROW("o_02"))*REF(COLUMN("quantity"),ROW("o_02"))',
  ],
  [
    formulaKey("b_03", "total"),
    '=REF(COLUMN("price"),ROW("b_03"))*REF(COLUMN("quantity"),ROW("b_03"))',
  ],
  [
    formulaKey("g_04", "total"),
    '=REF(COLUMN("price"),ROW("g_04"))*REF(COLUMN("quantity"),ROW("g_04"))',
  ],
  [
    formulaKey("p_05", "total"),
    '=REF(COLUMN("price"),ROW("p_05"))*REF(COLUMN("quantity"),ROW("p_05"))',
  ],
  [
    formulaKey("p_06", "total"),
    '=REF(COLUMN("price"),ROW("p_06"))*REF(COLUMN("quantity"),ROW("p_06"))',
  ],
  [
    formulaKey("m_07", "total"),
    '=REF(COLUMN("price"),ROW("m_07"))*REF(COLUMN("quantity"),ROW("m_07"))',
  ],
  [
    formulaKey("s_08", "total"),
    '=REF(COLUMN("price"),ROW("s_08"))*REF(COLUMN("quantity"),ROW("s_08"))',
  ],
]);

const columnDefs: ColDef<RowData>[] = [
  { field: "product" },
  { field: "price", valueFormatter: currencyFormatter },
  { field: "quantity", maxWidth: 120 },
  { field: "total", allowFormula: true, valueFormatter: currencyFormatter },
];

const rowData: RowData[] = [
  { id: "a_01", product: "Apples", price: 1.2, quantity: 5 },
  { id: "o_02", product: "Oranges", price: 0.8, quantity: 8 },
  { id: "b_03", product: "Bananas", price: 1.6, quantity: 1 },
  { id: "g_04", product: "Grapes", price: 1, quantity: 2 },
  { id: "p_05", product: "Plums", price: 0.4, quantity: 18 },
  { id: "p_06", product: "Peaches", price: 1.6, quantity: 4 },
  { id: "m_07", product: "Mangos", price: 2.2, quantity: 5 },
  { id: "s_08", product: "Strawberries", price: 0.8, quantity: 8 },
];

const gridOptions: GridOptions<RowData> = {
  columnDefs,
  rowData,
  getRowId,
  defaultColDef: {
    editable: true,
    flex: 1,
  },
  // Store formulas externally so rowData stays raw
  formulaDataSource: {
    getFormula: ({ column, rowNode }) => {
      return formulaStore.get(formulaKey(rowNode.id!, column.getColId()));
    },
    setFormula: ({ column, rowNode, formula }) => {
      const key = formulaKey(rowNode.id!, column.getColId());
      if (formula === undefined) {
        formulaStore.delete(key);
      } else {
        formulaStore.set(key, formula);
      }
    },
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).seeRowData = seeRowData;
  (<any>window).seeFormulas = seeFormulas;
}
```

[Live example: Formula Data Source](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas-formula-data-source/typescript/)

A user-provided data source should implement the following interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `init` | `Function` |  |  |  |
| `getFormula` | `Function` |  |  |  |
| `setFormula` | `Function` |  |  |  |
| `destroy` | `Function` |  |  |  |

### Caching

When a data source is configured, `getFormula` is called lazily and the result is cached per cell. The cache is invalidated automatically when:

- A cell in the row is edited through the grid (cell editor, `rowNode.setDataValue`, or any update that dispatches `cellValueChanged`).
- The Client-Side Row Model refreshes the row (add, remove, update, reorder).
- Columns are added, removed, or reordered.

If the formula store is mutated outside the grid (for example, syncing from a backend), call `api.refreshFormulas()` to invalidate every cached formula, or `api.refreshFormulas(rowNode)` / `api.refreshFormulas(rowId)` to invalidate a single row. Changes written only to the external store are not picked up until the cache is invalidated by one of the events above or by an explicit call.

## Exporting

During a [CSV Export](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/csv-export/), the grid exports the evaluated values of any formulas. During an [Excel Export](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/excel-export/), the grid exports the formulas themselves so Excel can evaluate them.

## Calculated Columns

Formulas apply to individual cells: a user types an expression into one cell, and only that cell is affected.

To derive a value for every row instead, use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/calculated-columns/). A calculated column defines one expression that evaluates against each row, referencing other columns by `colId`. Users can add their own calculated columns at runtime through the Column Menu.

```js
const gridOptions = {
    calculatedColumns: true,
    columnDefs: [
        { field: 'revenue' },
        { field: 'cost' },
        { colId: 'profit', headerName: 'Profit', calculatedExpression: '[revenue] - [cost]' },
    ],

    // other grid options ...
}
```

Use Formulas for ad-hoc, per-cell expressions; use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/calculated-columns/) for a derived value that applies to every row.

## See also

- [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-editor-component/) – The rich editing experience for formula cells, including autocomplete and range selection tools.
- [Formula Reference](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-reference/) – Full reference for operators (+, -, *, /, ^, &, comparisons), provided functions, and errors.
- [Custom Functions](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/formula-custom-functions/) – How to register and implement custom functions for formulas.


---
product: "AG Grid"
title: "Formulas"
description: "Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Formula Editor"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-editor-component/"
    - title: "Formula Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-reference/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-custom-functions/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Formulas

Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/formula-editor-demo.BvoS4BcB.mp4)

## Enabling Formulas

To enable formulas, set the column property `allowFormula: true` on one or more columns and ensure rows have [Row IDs](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-ids/#row-ids).

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    :cellSelection="cellSelection"
    :getRowId="getRowId"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: 'product' },
    { field: 'price' },
    { field: 'quantity' },
    { field: 'subtotal', allowFormula: true },
    { field: 'tax', allowFormula: true },
    { field: 'total', allowFormula: true },
];
this.cellSelection = {
    handle: {
        mode: 'fill',
    },
};
this.getRowId = (params) => String(params.data.rid);
```

#### Formulas

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, FormulaModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  CellSelectionModule,
  ClientSideRowModelModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
]);

const valueFormatter = ({ value }: ValueFormatterParams) =>
  `$ ${Number(value).toFixed(2)}`;

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :getRowId="getRowId"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="cellSelection"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) =>
      String(params.data.id),
    );
    const columnDefs = ref<ColDef[]>([
      { field: "product" },
      { field: "price", valueFormatter: valueFormatter },
      { field: "quantity", headerName: "Qty", maxWidth: 100 },
      { field: "subtotal", valueFormatter: valueFormatter, allowFormula: true },
      {
        field: "tax",
        headerName: "Tax (10%)",
        valueFormatter: valueFormatter,
        allowFormula: true,
      },
      { field: "total", valueFormatter: valueFormatter, allowFormula: true },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
    });
    const cellSelection = ref<boolean | CellSelectionOptions>({
      handle: {
        mode: "fill",
      },
    });
    const rowData = ref<any[] | null>([
      {
        id: 1,
        product: "Apples",
        price: 1.25,
        quantity: 4,
        subtotal: '=REF(COLUMN("price"),ROW(1))*REF(COLUMN("quantity"),ROW(1))',
        tax: '=REF(COLUMN("subtotal"),ROW(1))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(1))+REF(COLUMN("tax"),ROW(1))',
      },
      {
        id: 2,
        product: "Oranges",
        price: 0.8,
        quantity: 6,
        subtotal: '=REF(COLUMN("price"),ROW(2))*REF(COLUMN("quantity"),ROW(2))',
        tax: '=REF(COLUMN("subtotal"),ROW(2))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(2))+REF(COLUMN("tax"),ROW(2))',
      },
      {
        id: 3,
        product: "Bananas",
        price: 0.5,
        quantity: 10,
        subtotal: '=REF(COLUMN("price"),ROW(3))*REF(COLUMN("quantity"),ROW(3))',
        tax: '=REF(COLUMN("subtotal"),ROW(3))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(3))+REF(COLUMN("tax"),ROW(3))',
      },
      {
        id: 4,
        product: "Grapes",
        price: 2.1,
        quantity: 3,
        subtotal: '=REF(COLUMN("price"),ROW(4))*REF(COLUMN("quantity"),ROW(4))',
        tax: '=REF(COLUMN("subtotal"),ROW(4))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(4))+REF(COLUMN("tax"),ROW(4))',
      },
      {
        id: 5,
        product: "Plums",
        price: 1.5,
        quantity: 2,
        subtotal: '=REF(COLUMN("price"),ROW(5))*REF(COLUMN("quantity"),ROW(5))',
        tax: '=REF(COLUMN("subtotal"),ROW(5))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(5))+REF(COLUMN("tax"),ROW(5))',
      },
      {
        id: 6,
        product: "Peaches",
        price: 1,
        quantity: 3,
        subtotal: '=REF(COLUMN("price"),ROW(6))*REF(COLUMN("quantity"),ROW(6))',
        tax: '=REF(COLUMN("subtotal"),ROW(6))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(6))+REF(COLUMN("tax"),ROW(6))',
      },
      {
        id: 7,
        product: "Mangos",
        price: 2.45,
        quantity: 1,
        subtotal: '=REF(COLUMN("price"),ROW(7))*REF(COLUMN("quantity"),ROW(7))',
        tax: '=REF(COLUMN("subtotal"),ROW(7))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(7))+REF(COLUMN("tax"),ROW(7))',
      },
      {
        id: 8,
        product: "Strawberries",
        price: 1.8,
        quantity: 4,
        subtotal: '=REF(COLUMN("price"),ROW(8))*REF(COLUMN("quantity"),ROW(8))',
        tax: '=REF(COLUMN("subtotal"),ROW(8))*0.1',
        total: '=REF(COLUMN("subtotal"),ROW(8))+REF(COLUMN("tax"),ROW(8))',
      },
    ]);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      getRowId,
      columnDefs,
      defaultColDef,
      cellSelection,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Formulas](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas/vue3/)

## Formula Editor Component

The Formula Cell Editor is the default editor for `allowFormula: true` columns unless a custom `cellEditor` is provided. It tokenises references, highlights ranges, and provides function autocomplete while typing.

To opt out, set a `cellEditor` on the column. Formulas still evaluate, but the formula editor features are disabled.

See [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-editor-component/) for details and examples.

## Formula Syntax

Formulas are text strings that start with an equals sign (`=`) and can contain references, functions, operators, and constants.

### Basics

- `=` prefix indicates a formula.
- Constants can be numbers (e.g. `3.14`, `-7`), strings (e.g. `"Hello"`), or booleans (`TRUE`, `FALSE`).
- Standard operator precedence applies (BODMAS/PEMDAS).

### Cell References

Cell references use column letters plus row numbers (e.g. `A1`, `B2`). Rows are 1-based and columns continue past `Z` with `AA`, `AB`, `AC`, and so on.

Relative references move as the grid changes. Absolute references stay fixed using `$`:

- `=$A$1` locks column and row.
- `=A$1` locks the row only.
- `=$A1` locks the column only.

#### Long-Form References

The grid stores formulas in a long-hand format using column and row IDs so references remain valid across row and column changes that happen while the grid is not displaying the data. The editor converts them back to shorthand when users edit a cell.

If formulas are supplied directly in data, use the long-hand format to avoid row position drift. See the notes in [Formula Reference](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-reference/) for the conversion rules.

### Cell Ranges

Ranges refer to a block of cells using a top-left and bottom-right reference separated by `:` (e.g. `A1:B2`).

### Functions

Formulas support built-in functions such as `SUM`, `AVERAGE`, and `CONCAT`. See [Formula Reference](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-reference/) for the full list of supported functions, errors, and operators.

## Feature Interactions / Compatibility

| Feature | Status | Notes |
| --- | --- | --- |
| [Fill Handle](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-selection-fill-handle/) | Supported | Dragging from a formula offsets relative refs to the target row (e.g. `=B1+C2` becomes `=B2+C3`), so with a filter active they follow the visible rows. Absolute refs remain fixed. |
| [Cell Selection](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-selection/) | Supported | Required for range highlights and range handle editing in the formula editor. |
| [Row Numbers](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-numbers/) | Supported | Enabled by default; clicking a row number adds a row range to the formula. |
| [Cell Expressions](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-expressions/#cell-expressions) | Not supported |  |
| [Tree Data](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tree-data/) and [Row Grouping](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping/) | Not supported |  |
| [Pivoting](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/pivoting/) and [Aggregation](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/aggregation/) | Not supported |  |
| [Master Detail](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/master-detail/) | Not supported |  |
| [Server-Side](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/server-side-model/), [Infinite](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/infinite-scrolling/), and [Viewport](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/viewport/) Row Models | Not supported |  |

## Formula Data Source

Formulas can be backed by a custom data source. This example uses a Map-based store for formula values:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    :formulaDataSource="formulaDataSource"
    /* other grid options ... */>
</ag-grid-vue>

const formulaStore = new Map();
const formulaKey = (rowId, colId) => `${rowId}-${colId}`;

this.columnDefs = [
    { field: 'sales' },
    { field: 'tax', allowFormula: true },
];
this.formulaDataSource = {
    getFormula: ({ column, rowNode }) => formulaStore.get(formulaKey(rowNode.id, column.getColId())),
    setFormula: ({ column, rowNode, formula }) => {
        const key = formulaKey(rowNode.id, column.getColId());
        if (formula === undefined) {
            formulaStore.delete(key);
        } else {
            formulaStore.set(key, formula);
        }
    },
};
```

#### Formula Data Source

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FormulaDataSource,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  RowApiModule,
  TextEditorModule,
  ValueFormatterFunc,
  enableDevValidations,
} from "ag-grid-community";
import { FormulaModule } from "ag-grid-enterprise";
import { RowData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowApiModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
]);

const currencyFormatter: ValueFormatterFunc<RowData> = ({ value }) =>
  `$ ${Number(value ?? 0).toFixed(2)}`;

const formulaKey = (rowId: string, colId: string) => `${rowId}-${colId}`;

// Simple in-memory store to keep formulas outside rowData
// .. initialise with some initial formulas.
// .. Note: formulas in the grid are normalised into the long-hand format as shown below. As such, when using
//          an external data store, formulas will be stored in this long-hand format. Users can and should continue
//          to use the short-hand format.
//          See https://www.ag-grid.com/javascript-data-grid/formulas/#long-form-references for more.
const formulaStore = new Map<string, string>([
  [
    formulaKey("a_01", "total"),
    '=REF(COLUMN("price"),ROW("a_01"))*REF(COLUMN("quantity"),ROW("a_01"))',
  ],
  [
    formulaKey("o_02", "total"),
    '=REF(COLUMN("price"),ROW("o_02"))*REF(COLUMN("quantity"),ROW("o_02"))',
  ],
  [
    formulaKey("b_03", "total"),
    '=REF(COLUMN("price"),ROW("b_03"))*REF(COLUMN("quantity"),ROW("b_03"))',
  ],
  [
    formulaKey("g_04", "total"),
    '=REF(COLUMN("price"),ROW("g_04"))*REF(COLUMN("quantity"),ROW("g_04"))',
  ],
  [
    formulaKey("p_05", "total"),
    '=REF(COLUMN("price"),ROW("p_05"))*REF(COLUMN("quantity"),ROW("p_05"))',
  ],
  [
    formulaKey("p_06", "total"),
    '=REF(COLUMN("price"),ROW("p_06"))*REF(COLUMN("quantity"),ROW("p_06"))',
  ],
  [
    formulaKey("m_07", "total"),
    '=REF(COLUMN("price"),ROW("m_07"))*REF(COLUMN("quantity"),ROW("m_07"))',
  ],
  [
    formulaKey("s_08", "total"),
    '=REF(COLUMN("price"),ROW("s_08"))*REF(COLUMN("quantity"),ROW("s_08"))',
  ],
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 5px">
        <button v-on:click="seeRowData()">See Row Data</button>
        <button v-on:click="seeFormulas()">See Formulas</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :getRowId="getRowId"
        :columnDefs="columnDefs"
        :rowData="rowData"
        :defaultColDef="defaultColDef"
        :formulaDataSource="formulaDataSource"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<RowData> | null>(null);
    const getRowId = ref<GetRowIdFunc>((params) => String(params.data.id));
    const columnDefs = ref<ColDef[]>([
      { field: "product" },
      { field: "price", valueFormatter: currencyFormatter },
      { field: "quantity", maxWidth: 120 },
      { field: "total", allowFormula: true, valueFormatter: currencyFormatter },
    ]);
    const rowData = ref<RowData[] | null>([
      { id: "a_01", product: "Apples", price: 1.2, quantity: 5 },
      { id: "o_02", product: "Oranges", price: 0.8, quantity: 8 },
      { id: "b_03", product: "Bananas", price: 1.6, quantity: 1 },
      { id: "g_04", product: "Grapes", price: 1, quantity: 2 },
      { id: "p_05", product: "Plums", price: 0.4, quantity: 18 },
      { id: "p_06", product: "Peaches", price: 1.6, quantity: 4 },
      { id: "m_07", product: "Mangos", price: 2.2, quantity: 5 },
      { id: "s_08", product: "Strawberries", price: 0.8, quantity: 8 },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
    });
    const formulaDataSource = ref<FormulaDataSource>({
      getFormula: ({ column, rowNode }) => {
        return formulaStore.get(formulaKey(rowNode.id!, column.getColId()));
      },
      setFormula: ({ column, rowNode, formula }) => {
        const key = formulaKey(rowNode.id!, column.getColId());
        if (formula === undefined) {
          formulaStore.delete(key);
        } else {
          formulaStore.set(key, formula);
        }
      },
    });

    function seeRowData() {
      gridApi.value.forEachNode((node) =>
        console.log(
          `Row ${node.rowIndex}, ID: ${node.id}, Data: ${JSON.stringify(node.data)}`,
        ),
      );
    }
    function seeFormulas() {
      if (formulaStore.size === 0) {
        console.log("No formulas in store");
      } else {
        console.log("Stored formulas:");
        formulaStore.forEach((value, key) =>
          console.log(`Key: ${key}, Formula: ${value}`),
        );
      }
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      getRowId,
      columnDefs,
      rowData,
      defaultColDef,
      formulaDataSource,
      onGridReady,
      seeRowData,
      seeFormulas,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Formula Data Source](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas-formula-data-source/vue3/)

A user-provided data source should implement the following interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `init` | `Function` |  |  |  |
| `getFormula` | `Function` |  |  |  |
| `setFormula` | `Function` |  |  |  |
| `destroy` | `Function` |  |  |  |

### Caching

When a data source is configured, `getFormula` is called lazily and the result is cached per cell. The cache is invalidated automatically when:

- A cell in the row is edited through the grid (cell editor, `rowNode.setDataValue`, or any update that dispatches `cellValueChanged`).
- The Client-Side Row Model refreshes the row (add, remove, update, reorder).
- Columns are added, removed, or reordered.

If the formula store is mutated outside the grid (for example, syncing from a backend), call `api.refreshFormulas()` to invalidate every cached formula, or `api.refreshFormulas(rowNode)` / `api.refreshFormulas(rowId)` to invalidate a single row. Changes written only to the external store are not picked up until the cache is invalidated by one of the events above or by an explicit call.

## Exporting

During a [CSV Export](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/csv-export/), the grid exports the evaluated values of any formulas. During an [Excel Export](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/excel-export/), the grid exports the formulas themselves so Excel can evaluate them.

## Calculated Columns

Formulas apply to individual cells: a user types an expression into one cell, and only that cell is affected.

To derive a value for every row instead, use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/calculated-columns/). A calculated column defines one expression that evaluates against each row, referencing other columns by `colId`. Users can add their own calculated columns at runtime through the Column Menu.

```ts
<ag-grid-vue
    :calculatedColumns="calculatedColumns"
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.calculatedColumns = true;
this.columnDefs = [
    { field: 'revenue' },
    { field: 'cost' },
    { colId: 'profit', headerName: 'Profit', calculatedExpression: '[revenue] - [cost]' },
];
```

Use Formulas for ad-hoc, per-cell expressions; use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/calculated-columns/) for a derived value that applies to every row.

## See also

- [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-editor-component/) – The rich editing experience for formula cells, including autocomplete and range selection tools.
- [Formula Reference](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-reference/) – Full reference for operators (+, -, *, /, ^, &, comparisons), provided functions, and errors.
- [Custom Functions](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/formula-custom-functions/) – How to register and implement custom functions for formulas.


---
product: "AG Grid"
title: "Formulas"
description: "Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Formula Editor"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-editor-component/"
    - title: "Formula Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-reference/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-custom-functions/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Formulas

Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/formula-editor-demo.BvoS4BcB.mp4)

## Enabling Formulas

To enable formulas, set the column property `allowFormula: true` on one or more columns and ensure rows have [Row IDs](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-ids/#row-ids).

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    [cellSelection]="cellSelection"
    [getRowId]="getRowId"
    /* other grid options ... */ />

this.columnDefs = [
    { field: 'product' },
    { field: 'price' },
    { field: 'quantity' },
    { field: 'subtotal', allowFormula: true },
    { field: 'tax', allowFormula: true },
    { field: 'total', allowFormula: true },
];
this.cellSelection = {
    handle: {
        mode: 'fill',
    },
};
this.getRowId = (params) => String(params.data.rid);
```

#### Formulas

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, FormulaModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  CellSelectionModule,
  ClientSideRowModelModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [getRowId]="getRowId"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="cellSelection"
    [rowData]="rowData"
  /> `,
})
export class AppComponent {
  getRowId: GetRowIdFunc = (params: GetRowIdParams) => String(params.data.id);
  columnDefs: ColDef[] = [
    { field: "product" },
    { field: "price", valueFormatter: valueFormatter },
    { field: "quantity", headerName: "Qty", maxWidth: 100 },
    { field: "subtotal", valueFormatter: valueFormatter, allowFormula: true },
    {
      field: "tax",
      headerName: "Tax (10%)",
      valueFormatter: valueFormatter,
      allowFormula: true,
    },
    { field: "total", valueFormatter: valueFormatter, allowFormula: true },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
  };
  cellSelection: boolean | CellSelectionOptions = {
    handle: {
      mode: "fill",
    },
  };
  rowData: any[] | null = [
    {
      id: 1,
      product: "Apples",
      price: 1.25,
      quantity: 4,
      subtotal: '=REF(COLUMN("price"),ROW(1))*REF(COLUMN("quantity"),ROW(1))',
      tax: '=REF(COLUMN("subtotal"),ROW(1))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(1))+REF(COLUMN("tax"),ROW(1))',
    },
    {
      id: 2,
      product: "Oranges",
      price: 0.8,
      quantity: 6,
      subtotal: '=REF(COLUMN("price"),ROW(2))*REF(COLUMN("quantity"),ROW(2))',
      tax: '=REF(COLUMN("subtotal"),ROW(2))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(2))+REF(COLUMN("tax"),ROW(2))',
    },
    {
      id: 3,
      product: "Bananas",
      price: 0.5,
      quantity: 10,
      subtotal: '=REF(COLUMN("price"),ROW(3))*REF(COLUMN("quantity"),ROW(3))',
      tax: '=REF(COLUMN("subtotal"),ROW(3))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(3))+REF(COLUMN("tax"),ROW(3))',
    },
    {
      id: 4,
      product: "Grapes",
      price: 2.1,
      quantity: 3,
      subtotal: '=REF(COLUMN("price"),ROW(4))*REF(COLUMN("quantity"),ROW(4))',
      tax: '=REF(COLUMN("subtotal"),ROW(4))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(4))+REF(COLUMN("tax"),ROW(4))',
    },
    {
      id: 5,
      product: "Plums",
      price: 1.5,
      quantity: 2,
      subtotal: '=REF(COLUMN("price"),ROW(5))*REF(COLUMN("quantity"),ROW(5))',
      tax: '=REF(COLUMN("subtotal"),ROW(5))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(5))+REF(COLUMN("tax"),ROW(5))',
    },
    {
      id: 6,
      product: "Peaches",
      price: 1,
      quantity: 3,
      subtotal: '=REF(COLUMN("price"),ROW(6))*REF(COLUMN("quantity"),ROW(6))',
      tax: '=REF(COLUMN("subtotal"),ROW(6))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(6))+REF(COLUMN("tax"),ROW(6))',
    },
    {
      id: 7,
      product: "Mangos",
      price: 2.45,
      quantity: 1,
      subtotal: '=REF(COLUMN("price"),ROW(7))*REF(COLUMN("quantity"),ROW(7))',
      tax: '=REF(COLUMN("subtotal"),ROW(7))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(7))+REF(COLUMN("tax"),ROW(7))',
    },
    {
      id: 8,
      product: "Strawberries",
      price: 1.8,
      quantity: 4,
      subtotal: '=REF(COLUMN("price"),ROW(8))*REF(COLUMN("quantity"),ROW(8))',
      tax: '=REF(COLUMN("subtotal"),ROW(8))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(8))+REF(COLUMN("tax"),ROW(8))',
    },
  ];
}

const valueFormatter = ({ value }: ValueFormatterParams) =>
  `$ ${Number(value).toFixed(2)}`;
```

[Live example: Formulas](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas/angular/)

## Formula Editor Component

The Formula Cell Editor is the default editor for `allowFormula: true` columns unless a custom `cellEditor` is provided. It tokenises references, highlights ranges, and provides function autocomplete while typing.

To opt out, set a `cellEditor` on the column. Formulas still evaluate, but the formula editor features are disabled.

See [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-editor-component/) for details and examples.

## Formula Syntax

Formulas are text strings that start with an equals sign (`=`) and can contain references, functions, operators, and constants.

### Basics

- `=` prefix indicates a formula.
- Constants can be numbers (e.g. `3.14`, `-7`), strings (e.g. `"Hello"`), or booleans (`TRUE`, `FALSE`).
- Standard operator precedence applies (BODMAS/PEMDAS).

### Cell References

Cell references use column letters plus row numbers (e.g. `A1`, `B2`). Rows are 1-based and columns continue past `Z` with `AA`, `AB`, `AC`, and so on.

Relative references move as the grid changes. Absolute references stay fixed using `$`:

- `=$A$1` locks column and row.
- `=A$1` locks the row only.
- `=$A1` locks the column only.

#### Long-Form References

The grid stores formulas in a long-hand format using column and row IDs so references remain valid across row and column changes that happen while the grid is not displaying the data. The editor converts them back to shorthand when users edit a cell.

If formulas are supplied directly in data, use the long-hand format to avoid row position drift. See the notes in [Formula Reference](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-reference/) for the conversion rules.

### Cell Ranges

Ranges refer to a block of cells using a top-left and bottom-right reference separated by `:` (e.g. `A1:B2`).

### Functions

Formulas support built-in functions such as `SUM`, `AVERAGE`, and `CONCAT`. See [Formula Reference](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-reference/) for the full list of supported functions, errors, and operators.

## Feature Interactions / Compatibility

| Feature | Status | Notes |
| --- | --- | --- |
| [Fill Handle](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-selection-fill-handle/) | Supported | Dragging from a formula offsets relative refs to the target row (e.g. `=B1+C2` becomes `=B2+C3`), so with a filter active they follow the visible rows. Absolute refs remain fixed. |
| [Cell Selection](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-selection/) | Supported | Required for range highlights and range handle editing in the formula editor. |
| [Row Numbers](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-numbers/) | Supported | Enabled by default; clicking a row number adds a row range to the formula. |
| [Cell Expressions](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-expressions/#cell-expressions) | Not supported |  |
| [Tree Data](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tree-data/) and [Row Grouping](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping/) | Not supported |  |
| [Pivoting](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/pivoting/) and [Aggregation](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/aggregation/) | Not supported |  |
| [Master Detail](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/master-detail/) | Not supported |  |
| [Server-Side](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/server-side-model/), [Infinite](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/infinite-scrolling/), and [Viewport](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/viewport/) Row Models | Not supported |  |

## Formula Data Source

Formulas can be backed by a custom data source. This example uses a Map-based store for formula values:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    [formulaDataSource]="formulaDataSource"
    /* other grid options ... */ />

const formulaStore = new Map();
const formulaKey = (rowId, colId) => `${rowId}-${colId}`;

this.columnDefs = [
    { field: 'sales' },
    { field: 'tax', allowFormula: true },
];
this.formulaDataSource = {
    getFormula: ({ column, rowNode }) => formulaStore.get(formulaKey(rowNode.id, column.getColId())),
    setFormula: ({ column, rowNode, formula }) => {
        const key = formulaKey(rowNode.id, column.getColId());
        if (formula === undefined) {
            formulaStore.delete(key);
        } else {
            formulaStore.set(key, formula);
        }
    },
};
```

#### Formula Data Source

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FormulaDataSource,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  RowApiModule,
  TextEditorModule,
  ValueFormatterFunc,
  enableDevValidations,
} from "ag-grid-community";
import { FormulaModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  RowApiModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
]);
import { RowData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 5px">
      <button (click)="seeRowData()">See Row Data</button>
      <button (click)="seeFormulas()">See Formulas</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [getRowId]="getRowId"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      [defaultColDef]="defaultColDef"
      [formulaDataSource]="formulaDataSource"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<RowData>;

  getRowId: GetRowIdFunc = (params) => String(params.data.id);
  columnDefs: ColDef[] = [
    { field: "product" },
    { field: "price", valueFormatter: currencyFormatter },
    { field: "quantity", maxWidth: 120 },
    { field: "total", allowFormula: true, valueFormatter: currencyFormatter },
  ];
  rowData: RowData[] | null = [
    { id: "a_01", product: "Apples", price: 1.2, quantity: 5 },
    { id: "o_02", product: "Oranges", price: 0.8, quantity: 8 },
    { id: "b_03", product: "Bananas", price: 1.6, quantity: 1 },
    { id: "g_04", product: "Grapes", price: 1, quantity: 2 },
    { id: "p_05", product: "Plums", price: 0.4, quantity: 18 },
    { id: "p_06", product: "Peaches", price: 1.6, quantity: 4 },
    { id: "m_07", product: "Mangos", price: 2.2, quantity: 5 },
    { id: "s_08", product: "Strawberries", price: 0.8, quantity: 8 },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
  };
  formulaDataSource: FormulaDataSource = {
    getFormula: ({ column, rowNode }) => {
      return formulaStore.get(formulaKey(rowNode.id!, column.getColId()));
    },
    setFormula: ({ column, rowNode, formula }) => {
      const key = formulaKey(rowNode.id!, column.getColId());
      if (formula === undefined) {
        formulaStore.delete(key);
      } else {
        formulaStore.set(key, formula);
      }
    },
  };

  seeRowData() {
    this.gridApi.forEachNode((node) =>
      console.log(
        `Row ${node.rowIndex}, ID: ${node.id}, Data: ${JSON.stringify(node.data)}`,
      ),
    );
  }

  seeFormulas() {
    if (formulaStore.size === 0) {
      console.log("No formulas in store");
    } else {
      console.log("Stored formulas:");
      formulaStore.forEach((value, key) =>
        console.log(`Key: ${key}, Formula: ${value}`),
      );
    }
  }

  onGridReady(params: GridReadyEvent<RowData>) {
    this.gridApi = params.api;
  }
}

const currencyFormatter: ValueFormatterFunc<RowData> = ({ value }) =>
  `$ ${Number(value ?? 0).toFixed(2)}`;
const formulaKey = (rowId: string, colId: string) => `${rowId}-${colId}`;
// Simple in-memory store to keep formulas outside rowData
// .. initialise with some initial formulas.
// .. Note: formulas in the grid are normalised into the long-hand format as shown below. As such, when using
//          an external data store, formulas will be stored in this long-hand format. Users can and should continue
//          to use the short-hand format.
//          See https://www.ag-grid.com/javascript-data-grid/formulas/#long-form-references for more.
const formulaStore = new Map<string, string>([
  [
    formulaKey("a_01", "total"),
    '=REF(COLUMN("price"),ROW("a_01"))*REF(COLUMN("quantity"),ROW("a_01"))',
  ],
  [
    formulaKey("o_02", "total"),
    '=REF(COLUMN("price"),ROW("o_02"))*REF(COLUMN("quantity"),ROW("o_02"))',
  ],
  [
    formulaKey("b_03", "total"),
    '=REF(COLUMN("price"),ROW("b_03"))*REF(COLUMN("quantity"),ROW("b_03"))',
  ],
  [
    formulaKey("g_04", "total"),
    '=REF(COLUMN("price"),ROW("g_04"))*REF(COLUMN("quantity"),ROW("g_04"))',
  ],
  [
    formulaKey("p_05", "total"),
    '=REF(COLUMN("price"),ROW("p_05"))*REF(COLUMN("quantity"),ROW("p_05"))',
  ],
  [
    formulaKey("p_06", "total"),
    '=REF(COLUMN("price"),ROW("p_06"))*REF(COLUMN("quantity"),ROW("p_06"))',
  ],
  [
    formulaKey("m_07", "total"),
    '=REF(COLUMN("price"),ROW("m_07"))*REF(COLUMN("quantity"),ROW("m_07"))',
  ],
  [
    formulaKey("s_08", "total"),
    '=REF(COLUMN("price"),ROW("s_08"))*REF(COLUMN("quantity"),ROW("s_08"))',
  ],
]);
```

[Live example: Formula Data Source](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas-formula-data-source/angular/)

A user-provided data source should implement the following interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `init` | `Function` |  |  |  |
| `getFormula` | `Function` |  |  |  |
| `setFormula` | `Function` |  |  |  |
| `destroy` | `Function` |  |  |  |

### Caching

When a data source is configured, `getFormula` is called lazily and the result is cached per cell. The cache is invalidated automatically when:

- A cell in the row is edited through the grid (cell editor, `rowNode.setDataValue`, or any update that dispatches `cellValueChanged`).
- The Client-Side Row Model refreshes the row (add, remove, update, reorder).
- Columns are added, removed, or reordered.

If the formula store is mutated outside the grid (for example, syncing from a backend), call `api.refreshFormulas()` to invalidate every cached formula, or `api.refreshFormulas(rowNode)` / `api.refreshFormulas(rowId)` to invalidate a single row. Changes written only to the external store are not picked up until the cache is invalidated by one of the events above or by an explicit call.

## Exporting

During a [CSV Export](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/csv-export/), the grid exports the evaluated values of any formulas. During an [Excel Export](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/excel-export/), the grid exports the formulas themselves so Excel can evaluate them.

## Calculated Columns

Formulas apply to individual cells: a user types an expression into one cell, and only that cell is affected.

To derive a value for every row instead, use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/calculated-columns/). A calculated column defines one expression that evaluates against each row, referencing other columns by `colId`. Users can add their own calculated columns at runtime through the Column Menu.

```ts
<ag-grid-angular
    [calculatedColumns]="calculatedColumns"
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.calculatedColumns = true;
this.columnDefs = [
    { field: 'revenue' },
    { field: 'cost' },
    { colId: 'profit', headerName: 'Profit', calculatedExpression: '[revenue] - [cost]' },
];
```

Use Formulas for ad-hoc, per-cell expressions; use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/calculated-columns/) for a derived value that applies to every row.

## See also

- [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-editor-component/) – The rich editing experience for formula cells, including autocomplete and range selection tools.
- [Formula Reference](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-reference/) – Full reference for operators (+, -, *, /, ^, &, comparisons), provided functions, and errors.
- [Custom Functions](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/formula-custom-functions/) – How to register and implement custom functions for formulas.


---
product: "AG Grid"
title: "Formulas"
description: "Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Formula Editor"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-editor-component/"
    - title: "Formula Reference"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-reference/"
    - title: "Custom Functions"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-custom-functions/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Formulas

Formulas let users enter spreadsheet-style expressions into grid cells so values update automatically when referenced data changes.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/formula-editor-demo.BvoS4BcB.mp4)

## Enabling Formulas

To enable formulas, set the column property `allowFormula: true` on one or more columns and ensure rows have [Row IDs](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-ids/#row-ids).

```jsx
const [columnDefs, setColumnDefs] = useState([
    { field: 'product' },
    { field: 'price' },
    { field: 'quantity' },
    { field: 'subtotal', allowFormula: true },
    { field: 'tax', allowFormula: true },
    { field: 'total', allowFormula: true },
]);
const cellSelection = useMemo(() => { 
	return {
        handle: {
            mode: 'fill',
        },
    };
}, []);
const getRowId = useCallback((params) => String(params.data.rid), []);

<AgGridReact
    columnDefs={columnDefs}
    cellSelection={cellSelection}
    getRowId={getRowId}
/>
```

#### Formulas

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, FormulaModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  CellSelectionModule,
  ClientSideRowModelModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
];

const valueFormatter = ({ value }: ValueFormatterParams) =>
  `$ ${Number(value).toFixed(2)}`;

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>([
    {
      id: 1,
      product: "Apples",
      price: 1.25,
      quantity: 4,
      subtotal: '=REF(COLUMN("price"),ROW(1))*REF(COLUMN("quantity"),ROW(1))',
      tax: '=REF(COLUMN("subtotal"),ROW(1))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(1))+REF(COLUMN("tax"),ROW(1))',
    },
    {
      id: 2,
      product: "Oranges",
      price: 0.8,
      quantity: 6,
      subtotal: '=REF(COLUMN("price"),ROW(2))*REF(COLUMN("quantity"),ROW(2))',
      tax: '=REF(COLUMN("subtotal"),ROW(2))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(2))+REF(COLUMN("tax"),ROW(2))',
    },
    {
      id: 3,
      product: "Bananas",
      price: 0.5,
      quantity: 10,
      subtotal: '=REF(COLUMN("price"),ROW(3))*REF(COLUMN("quantity"),ROW(3))',
      tax: '=REF(COLUMN("subtotal"),ROW(3))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(3))+REF(COLUMN("tax"),ROW(3))',
    },
    {
      id: 4,
      product: "Grapes",
      price: 2.1,
      quantity: 3,
      subtotal: '=REF(COLUMN("price"),ROW(4))*REF(COLUMN("quantity"),ROW(4))',
      tax: '=REF(COLUMN("subtotal"),ROW(4))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(4))+REF(COLUMN("tax"),ROW(4))',
    },
    {
      id: 5,
      product: "Plums",
      price: 1.5,
      quantity: 2,
      subtotal: '=REF(COLUMN("price"),ROW(5))*REF(COLUMN("quantity"),ROW(5))',
      tax: '=REF(COLUMN("subtotal"),ROW(5))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(5))+REF(COLUMN("tax"),ROW(5))',
    },
    {
      id: 6,
      product: "Peaches",
      price: 1,
      quantity: 3,
      subtotal: '=REF(COLUMN("price"),ROW(6))*REF(COLUMN("quantity"),ROW(6))',
      tax: '=REF(COLUMN("subtotal"),ROW(6))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(6))+REF(COLUMN("tax"),ROW(6))',
    },
    {
      id: 7,
      product: "Mangos",
      price: 2.45,
      quantity: 1,
      subtotal: '=REF(COLUMN("price"),ROW(7))*REF(COLUMN("quantity"),ROW(7))',
      tax: '=REF(COLUMN("subtotal"),ROW(7))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(7))+REF(COLUMN("tax"),ROW(7))',
    },
    {
      id: 8,
      product: "Strawberries",
      price: 1.8,
      quantity: 4,
      subtotal: '=REF(COLUMN("price"),ROW(8))*REF(COLUMN("quantity"),ROW(8))',
      tax: '=REF(COLUMN("subtotal"),ROW(8))*0.1',
      total: '=REF(COLUMN("subtotal"),ROW(8))+REF(COLUMN("tax"),ROW(8))',
    },
  ]);
  const getRowId = useCallback(
    (params: GetRowIdParams) => String(params.data.id),
    [],
  );
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "product" },
    { field: "price", valueFormatter: valueFormatter },
    { field: "quantity", headerName: "Qty", maxWidth: 100 },
    { field: "subtotal", valueFormatter: valueFormatter, allowFormula: true },
    {
      field: "tax",
      headerName: "Tax (10%)",
      valueFormatter: valueFormatter,
      allowFormula: true,
    },
    { field: "total", valueFormatter: valueFormatter, allowFormula: true },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
    };
  }, []);
  const cellSelection = useMemo<boolean | CellSelectionOptions>(() => {
    return {
      handle: {
        mode: "fill",
      },
    };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            getRowId={getRowId}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={cellSelection}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Formulas](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas/reactFunctionalTs/)

## Formula Editor Component

The Formula Cell Editor is the default editor for `allowFormula: true` columns unless a custom `cellEditor` is provided. It tokenises references, highlights ranges, and provides function autocomplete while typing.

To opt out, set a `cellEditor` on the column. Formulas still evaluate, but the formula editor features are disabled.

See [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-editor-component/) for details and examples.

## Formula Syntax

Formulas are text strings that start with an equals sign (`=`) and can contain references, functions, operators, and constants.

### Basics

- `=` prefix indicates a formula.
- Constants can be numbers (e.g. `3.14`, `-7`), strings (e.g. `"Hello"`), or booleans (`TRUE`, `FALSE`).
- Standard operator precedence applies (BODMAS/PEMDAS).

### Cell References

Cell references use column letters plus row numbers (e.g. `A1`, `B2`). Rows are 1-based and columns continue past `Z` with `AA`, `AB`, `AC`, and so on.

Relative references move as the grid changes. Absolute references stay fixed using `$`:

- `=$A$1` locks column and row.
- `=A$1` locks the row only.
- `=$A1` locks the column only.

#### Long-Form References

The grid stores formulas in a long-hand format using column and row IDs so references remain valid across row and column changes that happen while the grid is not displaying the data. The editor converts them back to shorthand when users edit a cell.

If formulas are supplied directly in data, use the long-hand format to avoid row position drift. See the notes in [Formula Reference](https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-reference/) for the conversion rules.

### Cell Ranges

Ranges refer to a block of cells using a top-left and bottom-right reference separated by `:` (e.g. `A1:B2`).

### Functions

Formulas support built-in functions such as `SUM`, `AVERAGE`, and `CONCAT`. See [Formula Reference](https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-reference/) for the full list of supported functions, errors, and operators.

## Feature Interactions / Compatibility

| Feature | Status | Notes |
| --- | --- | --- |
| [Fill Handle](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-selection-fill-handle/) | Supported | Dragging from a formula offsets relative refs to the target row (e.g. `=B1+C2` becomes `=B2+C3`), so with a filter active they follow the visible rows. Absolute refs remain fixed. |
| [Cell Selection](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-selection/) | Supported | Required for range highlights and range handle editing in the formula editor. |
| [Row Numbers](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-numbers/) | Supported | Enabled by default; clicking a row number adds a row range to the formula. |
| [Cell Expressions](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-expressions/#cell-expressions) | Not supported |  |
| [Tree Data](https://www.ag-grid.com/archive/36.2.0/react-data-grid/tree-data/) and [Row Grouping](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping/) | Not supported |  |
| [Pivoting](https://www.ag-grid.com/archive/36.2.0/react-data-grid/pivoting/) and [Aggregation](https://www.ag-grid.com/archive/36.2.0/react-data-grid/aggregation/) | Not supported |  |
| [Master Detail](https://www.ag-grid.com/archive/36.2.0/react-data-grid/master-detail/) | Not supported |  |
| [Server-Side](https://www.ag-grid.com/archive/36.2.0/react-data-grid/server-side-model/), [Infinite](https://www.ag-grid.com/archive/36.2.0/react-data-grid/infinite-scrolling/), and [Viewport](https://www.ag-grid.com/archive/36.2.0/react-data-grid/viewport/) Row Models | Not supported |  |

## Formula Data Source

Formulas can be backed by a custom data source. This example uses a Map-based store for formula values:

```jsx
const formulaStore = new Map();
const formulaKey = (rowId, colId) => `${rowId}-${colId}`;
const [columnDefs, setColumnDefs] = useState([
    { field: 'sales' },
    { field: 'tax', allowFormula: true },
]);
const formulaDataSource = {
    getFormula: ({ column, rowNode }) => formulaStore.get(formulaKey(rowNode.id, column.getColId())),
    setFormula: ({ column, rowNode, formula }) => {
        const key = formulaKey(rowNode.id, column.getColId());
        if (formula === undefined) {
            formulaStore.delete(key);
        } else {
            formulaStore.set(key, formula);
        }
    },
};

<AgGridReact
    columnDefs={columnDefs}
    formulaDataSource={formulaDataSource}
/>
```

#### Formula Data Source

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FormulaDataSource,
  GetRowIdFunc,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  RowApiModule,
  TextEditorModule,
  ValueFormatterFunc,
  enableDevValidations,
} from "ag-grid-community";
import { FormulaModule } from "ag-grid-enterprise";
import { RowData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  RowApiModule,
  FormulaModule,
  NumberEditorModule,
  TextEditorModule,
];

const currencyFormatter: ValueFormatterFunc<RowData> = ({ value }) =>
  `$ ${Number(value ?? 0).toFixed(2)}`;

const formulaKey = (rowId: string, colId: string) => `${rowId}-${colId}`;

// Simple in-memory store to keep formulas outside rowData
// .. initialise with some initial formulas.
// .. Note: formulas in the grid are normalised into the long-hand format as shown below. As such, when using
//          an external data store, formulas will be stored in this long-hand format. Users can and should continue
//          to use the short-hand format.
//          See https://www.ag-grid.com/javascript-data-grid/formulas/#long-form-references for more.
const formulaStore = new Map<string, string>([
  [
    formulaKey("a_01", "total"),
    '=REF(COLUMN("price"),ROW("a_01"))*REF(COLUMN("quantity"),ROW("a_01"))',
  ],
  [
    formulaKey("o_02", "total"),
    '=REF(COLUMN("price"),ROW("o_02"))*REF(COLUMN("quantity"),ROW("o_02"))',
  ],
  [
    formulaKey("b_03", "total"),
    '=REF(COLUMN("price"),ROW("b_03"))*REF(COLUMN("quantity"),ROW("b_03"))',
  ],
  [
    formulaKey("g_04", "total"),
    '=REF(COLUMN("price"),ROW("g_04"))*REF(COLUMN("quantity"),ROW("g_04"))',
  ],
  [
    formulaKey("p_05", "total"),
    '=REF(COLUMN("price"),ROW("p_05"))*REF(COLUMN("quantity"),ROW("p_05"))',
  ],
  [
    formulaKey("p_06", "total"),
    '=REF(COLUMN("price"),ROW("p_06"))*REF(COLUMN("quantity"),ROW("p_06"))',
  ],
  [
    formulaKey("m_07", "total"),
    '=REF(COLUMN("price"),ROW("m_07"))*REF(COLUMN("quantity"),ROW("m_07"))',
  ],
  [
    formulaKey("s_08", "total"),
    '=REF(COLUMN("price"),ROW("s_08"))*REF(COLUMN("quantity"),ROW("s_08"))',
  ],
]);

const GridExample = () => {
  const gridRef = useRef<AgGridReact<RowData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<RowData[]>([
    { id: "a_01", product: "Apples", price: 1.2, quantity: 5 },
    { id: "o_02", product: "Oranges", price: 0.8, quantity: 8 },
    { id: "b_03", product: "Bananas", price: 1.6, quantity: 1 },
    { id: "g_04", product: "Grapes", price: 1, quantity: 2 },
    { id: "p_05", product: "Plums", price: 0.4, quantity: 18 },
    { id: "p_06", product: "Peaches", price: 1.6, quantity: 4 },
    { id: "m_07", product: "Mangos", price: 2.2, quantity: 5 },
    { id: "s_08", product: "Strawberries", price: 0.8, quantity: 8 },
  ]);
  const getRowId = useCallback((params) => String(params.data.id), []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "product" },
    { field: "price", valueFormatter: currencyFormatter },
    { field: "quantity", maxWidth: 120 },
    { field: "total", allowFormula: true, valueFormatter: currencyFormatter },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
    };
  }, []);
  const formulaDataSource = useMemo<FormulaDataSource>(() => {
    return {
      getFormula: ({ column, rowNode }) => {
        return formulaStore.get(formulaKey(rowNode.id!, column.getColId()));
      },
      setFormula: ({ column, rowNode, formula }) => {
        const key = formulaKey(rowNode.id!, column.getColId());
        if (formula === undefined) {
          formulaStore.delete(key);
        } else {
          formulaStore.set(key, formula);
        }
      },
    };
  }, []);

  const seeRowData = useCallback(() => {
    gridRef.current!.api.forEachNode((node) =>
      console.log(
        `Row ${node.rowIndex}, ID: ${node.id}, Data: ${JSON.stringify(node.data)}`,
      ),
    );
  }, []);

  const seeFormulas = useCallback(() => {
    if (formulaStore.size === 0) {
      console.log("No formulas in store");
    } else {
      console.log("Stored formulas:");
      formulaStore.forEach((value, key) =>
        console.log(`Key: ${key}, Formula: ${value}`),
      );
    }
  }, [formulaStore]);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "5px" }}>
            <button onClick={seeRowData}>See Row Data</button>
            <button onClick={seeFormulas}>See Formulas</button>
          </div>

          <div style={gridStyle}>
            <AgGridReact<RowData>
              ref={gridRef}
              rowData={rowData}
              getRowId={getRowId}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              formulaDataSource={formulaDataSource}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Formula Data Source](https://www.ag-grid.com/archive/36.2.0/examples/formulas/formulas-formula-data-source/reactFunctionalTs/)

A user-provided data source should implement the following interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `init` | `Function` |  |  |  |
| `getFormula` | `Function` |  |  |  |
| `setFormula` | `Function` |  |  |  |
| `destroy` | `Function` |  |  |  |

### Caching

When a data source is configured, `getFormula` is called lazily and the result is cached per cell. The cache is invalidated automatically when:

- A cell in the row is edited through the grid (cell editor, `rowNode.setDataValue`, or any update that dispatches `cellValueChanged`).
- The Client-Side Row Model refreshes the row (add, remove, update, reorder).
- Columns are added, removed, or reordered.

If the formula store is mutated outside the grid (for example, syncing from a backend), call `api.refreshFormulas()` to invalidate every cached formula, or `api.refreshFormulas(rowNode)` / `api.refreshFormulas(rowId)` to invalidate a single row. Changes written only to the external store are not picked up until the cache is invalidated by one of the events above or by an explicit call.

## Exporting

During a [CSV Export](https://www.ag-grid.com/archive/36.2.0/react-data-grid/csv-export/), the grid exports the evaluated values of any formulas. During an [Excel Export](https://www.ag-grid.com/archive/36.2.0/react-data-grid/excel-export/), the grid exports the formulas themselves so Excel can evaluate them.

## Calculated Columns

Formulas apply to individual cells: a user types an expression into one cell, and only that cell is affected.

To derive a value for every row instead, use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/react-data-grid/calculated-columns/). A calculated column defines one expression that evaluates against each row, referencing other columns by `colId`. Users can add their own calculated columns at runtime through the Column Menu.

```jsx
const calculatedColumns = true;
const [columnDefs, setColumnDefs] = useState([
    { field: 'revenue' },
    { field: 'cost' },
    { colId: 'profit', headerName: 'Profit', calculatedExpression: '[revenue] - [cost]' },
]);

<AgGridReact
    calculatedColumns={calculatedColumns}
    columnDefs={columnDefs}
/>
```

Use Formulas for ad-hoc, per-cell expressions; use [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/react-data-grid/calculated-columns/) for a derived value that applies to every row.

## See also

- [Formula Editor Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-editor-component/) – The rich editing experience for formula cells, including autocomplete and range selection tools.
- [Formula Reference](https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-reference/) – Full reference for operators (+, -, *, /, ^, &, comparisons), provided functions, and errors.
- [Custom Functions](https://www.ag-grid.com/archive/36.2.0/react-data-grid/formula-custom-functions/) – How to register and implement custom functions for formulas.
